#!/usr/bin/env python3

import os
import argparse
import yaml
import csv

def make_title(config, default):

    if "title" in config:
        title = config["title"]
        if "#" not in title:
            title = "# " + title
    else:
        if config["sequencing_centre"] == "DEFAULT":
            title = default["title"]
        else:
            title = f'{default["title"]} for sequences generated by {config["sequencing_centre"]}'

    config["title"] = title

def report_date(config, default):

    if "report_date" in config:
        date = config["report_date"]
    else:
        date = default["report_date"]

    config["report_date"] = f'This investigation was started on {date}'


def multi_line_free_text(free_text_arg,config):

    if free_text_arg in config:
        
        start = config[free_text_arg].replace("'","")
        
        end = "print('''" + start + "''')"
             
        config[free_text_arg] = end

def authors(config):

    if "authors" in config:

        authors_str = config["authors"]

        config["authors"] = "**Authors**: " + authors_str


def outbreak_id(config):

    if "outbreak_id" in config:

        outbreak_id = config["outbreak_id"]

        config["outbreak_id"] = "**Outbreak ID**: " + outbreak_id

def free_text_args(config, default):
    
    free_text_args = ["description", "conclusions"]
    
    report_date(config, default)
    authors(config)
    outbreak_id(config)

    for i in free_text_args:
        multi_line_free_text(i, config)




    

    